
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <utilib.h>
#include "tones.h"

char *knx[] = {"Cb", "C", "C#", "Db", "D", "D#", "Eb", "E", "Fb", "E#", "F", "F#", "Gb", "G", "G#", "Ab", "A", "A#", "Bb", "B",  "B#", NULL};  
int k12[]   = {-10,  -9,  -8,   -8,   -7,  -6,   -6,   -5,   -5,   -4,  -4,   -3,   -3,   -2,  -1,   -1,   0,   1,    1,    2,    3,   0};
/*              0     1    2     3     4    5     6     7    8     9    10    11    12    13   14    15    16    17   18    19    20    21  */ 

int toneindex12(char *tname)
{
	int j; 
	for(j = 0; j<21; j++)
	{
		if(!strcmp(knx[j], tname))
		{
			return(k12[j]);
		}
	}
	return(0);
}

double tonefreq(char *txt, char **pstop)
{
	char tname[20];
	double Fnew, ddx; 
	double octaveno; 
	char *stop;

	strword(txt, &stop, tname, 20); 
	// printf("%s(%d): In %s found %s\n", __FILE__, __LINE__, txt, tname); 

	ddx = toneindex12(tname);
	// printf("%s(%d): In %s found %G follows %s\n", __FILE__, __LINE__, tname, ddx, stop); 

	octaveno = strtod(stop, &stop); 
	// printf("%s(%d): found %G\n", __FILE__, __LINE__, octaveno); 

	Fnew = 440.0 * pow(2.0, octaveno - 4.0 + ddx/12.0); 

	// printf("%s(%d): %s is %G\n", __FILE__, __LINE__, txt, Fnew); 

	*pstop = stop;
	return(Fnew);
}



